package rocks.zipcode.quiz5.objectorientation.account;

/**
 * @author leon on 27/12/2018.
 */
public class BankAccount extends Account implements Transactable {

    double balance = 0;

    public void setBalance(Double val) {
        balance = val;
    }

    @Override
    public void deposit(Double amountToIncreaseBy) {
        System.out.println(amountToIncreaseBy >= 0);
        if(amountToIncreaseBy >= 0.0) {
            balance += amountToIncreaseBy;
        } else {
            throw new IllegalArgumentException();
        }
    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) {
        System.out.println(amountToDecreaseBy);
        if(balance - amountToDecreaseBy >= 0 && amountToDecreaseBy >= 0) {
            balance -= amountToDecreaseBy;
        } else {
            throw new IllegalArgumentException();
        }
    }

    @Override
    public Double getBalance() {
        return balance;
    }
}
