package rocks.zipcode.quiz5.arrays;

import java.util.Arrays;

/**
 * @author leon on 01/01/2019.
 */
public class ArrayUtils {
    public static String getMiddleElement(String[] values) {
        int index = ((int)Math.floor(values.length / 2.0));
        return values[index];
    }

    public static String[] removeMiddleElement(String[] values) {
        int index = ((int)Math.floor(values.length / 2.0));
        String[] arr = new String[values.length - 1];
        String[] first = Arrays.copyOfRange(values, 0, index);
        String[] second = Arrays.copyOfRange(values, index + 1, values.length);
        return merge(first, second);
    }

    public static int getMiddleIndex(String[] values){
        return ((int)Math.floor(values.length / 2.0));

    }

    public static String[] merge(String[] value1, String[] value2){
        String[] arr = new String[value1.length + value2.length];
        int counter = 0;
        for(int i = 0; i < arr.length; i ++){
            if(i < value1.length){
                arr[i] = value1[i];
            } else {
                arr[i] = value2[counter];
                counter ++;
            }
        }
        return arr;
    }

    public static String concatToString(String[] value){
        String result = "";
        for(String string : value){
            result += string;
        }
        return result;
    }

    public static String getLastElement(String[] values) {
        return values[values.length - 1];
    }

    public static String[] removeLastElement(String[] values) {
        return Arrays.copyOfRange(values, 0, values.length - 1);
    }
}