package rocks.zipcode.quiz5.collections;

import java.util.*;

public class WordCounter {

    List<String> words = new ArrayList<>();

    public WordCounter(String... strings) {
        words.addAll(Arrays.asList(strings));
    }

    public Map<String, Integer> getWordCountMap() {
        Map<String, Integer> words = new HashMap<>();
        for(String word : this.words){
            if(words.containsKey(word)){
                int amount = words.get(word);
                amount = amount + 1;
                words.put(word, amount);
            } else {
                words.put(word, 1);
            }
        }
        return words;
    }
}
